VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "dwWindow"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Option Explicit

' Class dwWindow
' Hwnd control and configuration class
' Copyright (c) 1996 by Desaware Inc.
' Part of the Desaware API Classes Library
' All rights reserved

' These flags will activate certain functions that require
' classes that most functions do not need.  If you do not
' need to use a function that is triggered by a flag, you
' can set the flag to False, and prevent an unneeded class
' from being loaded.
#Const FlagGetDC = True  ' uses dwDeviceContext
#Const FlagRegion = True  ' uses dwRegion

Private iHwnd As Long ' Window handle assigned to this object

Private iLeft As Long ' These are for API Foundation Library Standard compatibility
Private iTop As Long
Private iWidth As Long
Private iHeight As Long


'********************Located In Chapter 5 Function Index *************************

#If Win32 Then
Private Declare Function apiIsWindowEnabled& Lib "user32" Alias "IsWindowEnabled" (ByVal hwnd As Long)
Private Declare Function apiGetDesktopWindow& Lib "user32" Alias "GetDesktopWindow" ()
Private Declare Function apiGetForegroundWindow& Lib "user32" Alias "GetForegroundWindow" ()
Private Declare Function apiGetParent& Lib "user32" Alias "GetParent" (ByVal hwnd As Long)
Private Declare Function apiGetTopWindow& Lib "user32" Alias "GetTopWindow" (ByVal hwnd As Long)
Private Declare Function apiGetWindow& Lib "user32" Alias "GetWindow" (ByVal hwnd As Long, ByVal wCmd As Long)
Private Declare Function apiGetWindowLong& Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long)
Private Declare Function apiGetWindowRect& Lib "user32" Alias "GetWindowRect" (ByVal hwnd As Long, lpRect As RECT)
Private Declare Function apiIsWindowUnicode& Lib "user32" Alias "IsWindowUnicode" (ByVal hwnd As Long)
Private Declare Function apiIsWindowVisible& Lib "user32" Alias "IsWindowVisible" (ByVal hwnd As Long)
Private Declare Function apiInvalidateRect& Lib "user32" Alias "InvalidateRect" (ByVal hwnd As Long, lpRect As RECT, ByVal bErase As Long)
Private Declare Function apiInvalidateRectBynum& Lib "user32" Alias "InvalidateRect" (ByVal hwnd As Long, ByVal lpRect As Long, ByVal bErase As Long)
Private Declare Function apiIsChild& Lib "user32" Alias "IsChild" (ByVal hWndParent As Long, ByVal hwnd As Long)
Private Declare Function apiIsIconic& Lib "user32" Alias "IsIconic" (ByVal hwnd As Long)
Private Declare Function apiIsZoomed& Lib "user32" Alias "IsZoomed" (ByVal hwnd As Long)
Private Declare Function apiLockWindowUpdate& Lib "user32" Alias "LockWindowUpdate" (ByVal hwndLock As Long)
Private Declare Function apiMoveWindow& Lib "user32" Alias "MoveWindow" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long)
Private Declare Function apiOpenIcon& Lib "user32" Alias "OpenIcon" (ByVal hwnd As Long)
Private Declare Function apiRedrawWindow& Lib "user32" Alias "RedrawWindow" (ByVal hwnd As Long, lprcUpdate As RECT, ByVal hRgnUpdate As Long, ByVal fuRedraw As Long)
Private Declare Function apiReleaseCapture& Lib "user32" Alias "ReleaseCapture" ()
Private Declare Function apiScreenToClient& Lib "user32" Alias "ScreenToClient" (ByVal hwnd As Long, lpPoint As POINTAPI)
Private Declare Function apiScrollWindow& Lib "user32" Alias "ScrollWindow" (ByVal hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As RECT, lpClipRect As RECT)
Private Declare Function apiScrollWindowByval& Lib "user32" Alias "ScrollWindow" (ByVal hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, ByVal lpRect As Long, ByVal lpClipRect As Long)
Private Declare Function apiScrollWindowEx& Lib "user32" Alias "ScrollWindowEx" (ByVal hwnd As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hRgnUpdate As Long, lprcUpdate As RECT, ByVal fuScroll As Long)
Private Declare Function apiScrollWindowExByval& Lib "user32" Alias "ScrollWindowEx" (ByVal hwnd As Long, ByVal dx As Long, ByVal dy As Long, ByVal lprcScroll As Long, ByVal lprcClip As Long, ByVal hRgnUpdate As Long, ByVal lprcUpdate As Long, ByVal fuScroll As Long)
Private Declare Function apiSetActiveWindow& Lib "user32" Alias "SetActiveWindow" (ByVal hwnd As Long)
Private Declare Function apiSetCapture& Lib "user32" Alias "SetCapture" (ByVal hwnd As Long)
Private Declare Function apiSetFocus& Lib "user32" Alias "SetFocus" (ByVal hwnd As Long)
Private Declare Function apiSetForegroundWindow& Lib "user32" Alias "SetForegroundWindow" (ByVal hwnd As Long)
Private Declare Function apiSetParent& Lib "user32" Alias "SetParent" (ByVal hWndChild As Long, ByVal hWndNewParent As Long)
Private Declare Function apiSetWindowPos& Lib "user32" Alias "SetWindowPos" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function apiSetWindowLong& Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long)
Private Declare Function apiSetWindowText& Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String)
Private Declare Function apiSetWindowWord% Lib "user32" Alias "SetWindowWord" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal wNewWord As Integer)
Private Declare Function apiShowOwnedPopups& Lib "user32" Alias "ShowOwnedPopups" (ByVal hwnd As Long, ByVal fshow As Long)
Private Declare Function apiShowWindow& Lib "user32" Alias "ShowWindow" (ByVal hwnd As Long, ByVal nCmdShow As Long)
Private Declare Function apiShowWindowAsync& Lib "user32" Alias "ShowWindowAsync" (ByVal hwnd As Long, ByVal nCmdShow As Long)
Private Declare Function apiValidateRect& Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
Private Declare Function apiValidateRectBynum& Lib "user32" Alias "ValidateRect" (ByVal hwnd As Long, ByVal lpRect As Long)
Private Declare Function apiArrangeIconicWindows& Lib "user32" Alias "ArrangeIconicWindows" (ByVal hwnd As Long)
Private Declare Function apiChildWindowFromPoint& Lib "user32" Alias "ChildWindowFromPoint" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long)
Private Declare Function apiChildWindowFromPointEx& Lib "user32" Alias "ChildWindowFromPointEx" (ByVal hWndParent As Long, ByVal ptx As Long, ByVal pty As Long, ByVal uFlags As Long)
Private Declare Function apiGetClassName& Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long)
Private Declare Function apiGetClassLong& Lib "user32" Alias "GetClassLongA" (ByVal hwnd As Long, ByVal nIndex As Long)
Private Declare Function apiFlashWindow& Lib "user32" Alias "FlashWindow" (ByVal hwnd As Long, ByVal bInvert As Long)

Private Declare Function apiFindWindowEx& Lib "user32" Alias "FindWindowExA" (ByVal hWndParent As Long, ByVal hWndChildAfter As Long, ByVal lpClassName As String, ByVal lpWindowName As String)
Private Declare Function apiEnableWindow& Lib "user32" Alias "EnableWindow" (ByVal hwnd As Long, ByVal fEnable As Long)
Private Declare Function apiCloseWindow& Lib "user32" Alias "CloseWindow" (ByVal hwnd As Long)
Private Declare Function apiClientToScreen& Lib "user32" Alias "ClientToScreen" (ByVal hwnd As Long, lpPoint As POINTAPI)
Private Declare Function apiDestroyWindow Lib "user32" Alias "DestroyWindow" (ByVal hwnd As Long) As Boolean
Private Declare Function apiBringWindowToTop& Lib "user32" Alias "BringWindowToTop" (ByVal hwnd As Long)
Private Declare Function apiWindowFromPoint& Lib "user32" Alias "WindowFromPoint" (ByVal x As Long, ByVal y As Long)

Private Declare Function apiGetClientRect& Lib "user32" Alias "GetClientRect" (ByVal hwnd As Long, lpRect As RECT)
Private Declare Function apiGetWindowText& Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long)
Private Declare Function apiGetWindowTextLength& Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long)
Private Declare Function apiIsWindow& Lib "user32" Alias "IsWindow" (ByVal hwnd As Long)
Private Declare Function apiUpdateWindow& Lib "user32" Alias "UpdateWindow" (ByVal hwnd As Long)

Private Declare Function apiInvalidateRgn& Lib "user32" Alias "InvalidateRgn" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bErase As Long)
Private Declare Function apiSendMessage& Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal nMsg As Integer, ByVal wParam As Long, ByVal lParam As Long)
Private Declare Sub apiDragAcceptFiles Lib "shell32.dll" Alias "DragAcceptFiles" (ByVal hwnd As Long, ByVal accept As Boolean)
#Else
Private Declare Function apiIsWindowEnabled% Lib "user" Alias "IsWindowEnabled" (ByVal hwnd As Integer)
Private Declare Function apiGetParent% Lib "user" Alias "GetParent" (ByVal hwnd As Integer)
Private Declare Function apiGetDesktopWindow% Lib "user" Alias "GetDesktopWindow" ()
Private Declare Function apiGetTopWindow% Lib "user" Alias "GetTopWindow" (ByVal hwnd As Integer)
Private Declare Function apiGetWindow% Lib "user" Alias "GetWindow" (ByVal hwnd As Integer, ByVal wCmd As Integer)
Private Declare Function apiGetWindowLong& Lib "user" Alias "GetWindowLong" (ByVal hwnd As Integer, ByVal nIndex As Integer)
Private Declare Sub apiGetWindowRect Lib "user" Alias "GetWindowRect" (ByVal hwnd As Integer, lpRect As RECT)
'Function IsWindowUnicode is not available in the WIN16 API.
Private Declare Function apiIsWindowVisible% Lib "user" Alias "IsWindowVisible" (ByVal hwnd As Integer)
Private Declare Sub apiInvalidateRect Lib "user" Alias "InvalidateRect" (ByVal hwnd As Integer, lpRect As RECT, ByVal bErase As Integer)
Private Declare Sub apiInvalidateRectBynum Lib "user" Alias "InvalidateRect" (ByVal hwnd As Integer, ByVal lpRect As Long, ByVal bErase As Integer)
Private Declare Function apiIsChild% Lib "user" Alias "IsChild" (ByVal hWndParent As Integer, ByVal hwnd As Integer)
Private Declare Function apiIsIconic% Lib "user" Alias "IsIconic" (ByVal hwnd As Integer)
Private Declare Function apiIsZoomed% Lib "user" Alias "IsZoomed" (ByVal hwnd As Integer)
Private Declare Function apiLockWindowUpdate% Lib "user" Alias "LockWindowUpdate" (ByVal hwnd As Integer)
Private Declare Sub apiMoveWindow Lib "user" Alias "MoveWindow" (ByVal hwnd As Integer, ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal bRepaint As Integer)
Private Declare Function apiOpenIcon% Lib "user" Alias "OpenIcon" (ByVal hwnd As Integer)
Private Declare Function apiRedrawWindow% Lib "user" Alias "RedrawWindow" (ByVal hwnd As Integer, lprcUpdate As RECT, ByVal hRgnUpdate As Integer, ByVal fuRedraw As Integer)
Private Declare Sub apiReleaseCapture Lib "user" Alias "ReleaseCapture" ()
Private Declare Sub apiScreenToClient Lib "user" (ByVal hwnd As Integer, lpPoint As POINTAPI)
Private Declare Sub apiScrollWindow Lib "user" Alias "ScrollWindow" (ByVal hwnd As Integer, ByVal XAmount As Integer, ByVal YAmount As Integer, lpRect As RECT, lpClipRect As RECT)
Private Declare Sub apiScrollWindowByval Lib "user" Alias "ScrollWindow" (ByVal hwnd As Long, ByVal XAmount As Integer, ByVal YAmount As Integer, ByVal lpRect As Long, ByVal lpClipRect As Long)
Private Declare Sub apiScrollWindowEx Lib "user" Alias "ScrollWindowEx" (ByVal hwnd As Integer, ByVal dx As Integer, ByVal dy As Integer, lprcScroll As RECT, lprcClip As RECT, ByVal hRgnUpdate As Integer, lprcUpdate As RECT, ByVal fuScroll As Integer)
Private Declare Function apiSetActiveWindow% Lib "user" Alias "SetActiveWindow" (ByVal hwnd As Integer)
Private Declare Function apiSetCapture% Lib "user" Alias "SetCapture" (ByVal hwnd As Integer)
Private Declare Function apiSetFocus% Lib "user" Alias "SetFocus" (ByVal hwnd As Integer)
'Function SetForegroundWindow is not available in the WIN16 API.
Private Declare Function apiSetParent% Lib "user" Alias "SetParent" (ByVal hWndChild As Integer, ByVal hWndNewParent As Integer)
Private Declare Sub apiSetWindowPos Lib "user" Alias "SetWindowPos " (ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer)
Private Declare Sub apiSetWindowText Lib "user" Alias "SetWindowText" (ByVal hwnd As Integer, ByVal lpString As String)
' are those indexes supposed to be long?
Private Declare Function apiSetWindowLong% Lib "user" Alias "SetWindowLong" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long)
Private Declare Function apiSetWindowWord% Lib "user" Alias "SetWindowWord" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal wNewWord As Integer)
Private Declare Sub apiShowOwnedPopups Lib "user" Alias "ShowOwnedPopups" (ByVal hwnd As Integer, ByVal fshow As Integer)
Private Declare Function apiShowWindow% Lib "user" Alias "ShowWindow" (ByVal hwnd As Integer, ByVal nCmdShow As Integer)
'Function ShowWindowAsync is not available in the WIN16 API.
Private Declare Sub apiValidateRect Lib "user" (ByVal hwnd As Integer, lpRect As RECT)
Private Declare Sub apiValidateRectBynum Lib "user" Alias "ValidateRect" (ByVal hwnd As Integer, ByVal lpRect As Long)
Private Declare Function apiArrangeIconicWindows% Lib "user" Alias "ArrangeIconicWindows" (ByVal hwnd As Integer)
Private Declare Sub apiBringWindowToTop Lib "user" Alias "BringWindowToTop " (ByVal hwnd As Integer)
Private Declare Function apiChildWindowFromPoint% Lib "user" Alias "ChildWindowFromPoint" (ByVal hwnd As Integer, ByVal pnt As Any)
'Function ChildWindowFromPointEx is not available in the WIN16 API.
Private Declare Function apiGetClassName% Lib "user" Alias "GetClassName" (ByVal hwnd As Integer, ByVal lpClassName As String, ByVal nMaxCount As Integer)
Private Declare Function apiFlashWindow% Lib "user" Alias "FlashWindow" (ByVal hwnd As Integer, ByVal bInvert As Integer)
Private Declare Function apiEnableWindow% Lib "user" Alias "EnableWindow" (ByVal hwnd As Integer, ByVal aBOOL As Integer)
Private Declare Sub apiCloseWindow Lib "user" Alias "CloseWindow" (ByVal hwnd As Integer)
Private Declare Function apiDestroyWindow% Lib "user" Alias "DestroyWindow" (ByVal hwnd As Integer)
Private Declare Sub apiClientToScreen Lib "user" Alias "ClientToScreen" (ByVal hwnd As Integer, lpPoint As POINTAPI)
Private Declare Function apiWindowFromPoint% Lib "user" Alias "WindowFromPoint" (ByVal pnt As Any)

Private Declare Function apiGetClientRect% Lib "user" Alias "GetClientRect" (ByVal hwnd As Integer, lpRect As RECT)
Private Declare Function apiGetWindowText% Lib "user" Alias "GetWindowText" (ByVal hwnd As Integer, ByVal lpString As String, ByVal aint As Integer)
Private Declare Function apiGetWindowTextLength% Lib "user" Alias "GetWindowTextLength" (ByVal hwnd As Integer)
Private Declare Function apiIsWindow% Lib "user" Alias "IsWindow" (ByVal hwnd As Integer)
Private Declare Sub apiUpdateWindow Lib "user" Alias "UpdateWindow" (ByVal hwnd As Integer)
Private Declare Function apiGetClassLong& Lib "user" Alias "GetClassLong" (ByVal hwnd As Integer, ByVal nIndex As Integer)

Private Declare Function apiInvalidateRgn% Lib "user" Alias "InvalidateRgn" (ByVal hwnd As Integer, ByVal hRgn As Integer, ByVal bErase As Integer)
Private Declare Function apiSendMessage& Lib "user" Alias "SendMessage" (ByVal hwnd As Integer, ByVal nMsg As Integer, ByVal wParam As Integer, ByVal lParam As Long)
Private Declare Sub apiDragAcceptFiles Lib "shell.dll" Alias "DragAcceptFiles" (ByVal hwnd As Integer, ByVal accept As Boolean)
#End If 'WIN16

Private Sub RaiseWinError(Optional errval)
    If IsMissing(errval) Then
        RaiseError DWERR_APIRESULT, "dwWindow"
    Else
        RaiseError errval, "dwWindow"
    End If
End Sub

Public Property Get hwnd() As Long
    hwnd = iHwnd
End Property

Public Property Let hwnd(vNewValue As Long)
    Dim tmpDwRect As New dwRECT
    
    If vNewValue = 0 Then
        iHwnd = vNewValue
        Exit Property
    End If
    
    If apiIsWindow(vNewValue) = 0 Then
        RaiseWinError 380
        Exit Property
    End If
    iHwnd = vNewValue
    
    Set tmpDwRect = GetWindowRect()
    iLeft = tmpDwRect.left
    iTop = tmpDwRect.top
    iWidth = tmpDwRect.right - tmpDwRect.left
    iHeight = tmpDwRect.bottom - tmpDwRect.top
    Set tmpDwRect = Nothing
End Property

Public Sub BringWindowToTop()
Attribute BringWindowToTop.VB_HelpID = 2804
Attribute BringWindowToTop.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiBringWindowToTop(iHwnd)
    If ret& = 0 Then RaiseWinError
#Else
    apiBringWindowToTop iHwnd
#End If
End Sub

Public Function GetWindowTextLength() As Long
Attribute GetWindowTextLength.VB_HelpID = 2953
Attribute GetWindowTextLength.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    GetWindowTextLength = apiGetWindowTextLength(iHwnd)
End Function

Public Function GetWindowText() As String
Attribute GetWindowText.VB_HelpID = 2952
Attribute GetWindowText.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim l&
    Dim r$
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    l = apiGetWindowTextLength(iHwnd)
    r$ = String$(l + 1, 0)
    ret& = apiGetWindowText(iHwnd, r$, l + 1)
    If ret& = 0 Then RaiseWinError
    GetWindowText = left$(r$, l)
End Function

Public Function GetClientRect() As dwRECT
Attribute GetClientRect.VB_HelpID = 2954
Attribute GetClientRect.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim rc As RECT
    Dim newRect As New dwRECT
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiGetClientRect(iHwnd, rc)
    #If Win32 Then
        If ret& = 0 Then RaiseWinError
    #End If
    Call newRect.SetRect(rc.left, rc.top, rc.right, rc.bottom)
    Set GetClientRect = newRect
End Function

#If FlagGetDC = True Then
Public Function GetDC() As dwDeviceContext
Attribute GetDC.VB_HelpID = 2922
Attribute GetDC.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim h As New dwDeviceContext
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    h.GetDC Me
    Set GetDC = h
End Function
#End If 'FlagGetDC

Public Function IsWindowEnabled() As Boolean
Attribute IsWindowEnabled.VB_HelpID = 2878
Attribute IsWindowEnabled.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsWindowEnabled(iHwnd) = 0 Then
        IsWindowEnabled = False
    Else
        IsWindowEnabled = True
    End If
End Function

Public Function GetParent() As dwWindow
Attribute GetParent.VB_HelpID = 3008
Attribute GetParent.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiGetParent(iHwnd)
    If ret& = 0 Then
        Set GetParent = newWindow
        Debug.Print "Window Has No Parent"
    Else
        newWindow.hwnd = ret&
        Set GetParent = newWindow
    End If
End Function

Public Function GetTopWindow() As dwWindow
Attribute GetTopWindow.VB_HelpID = 3012
Attribute GetTopWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiGetTopWindow(iHwnd)
    newWindow.hwnd = ret&
    Set GetTopWindow = newWindow
End Function

Public Function GetWindow(ByVal wCmd) As dwWindow
Attribute GetWindow.VB_HelpID = 3019
Attribute GetWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiGetWindow(iHwnd, wCmd)
    newWindow.hwnd = ret&
    Set GetWindow = newWindow
End Function

Public Function GetWindowLong(ByVal nIndex) As Long
Attribute GetWindowLong.VB_HelpID = 3001
Attribute GetWindowLong.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    GetWindowLong = apiGetWindowLong(iHwnd, nIndex)
End Function

Public Function GetWindowRect() As dwRECT
Attribute GetWindowRect.VB_HelpID = 2955
Attribute GetWindowRect.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim rc As RECT
    Dim newRect As New dwRECT
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiGetWindowRect(iHwnd, rc)
    If ret& = 0 Then RaiseWinError
#Else
    apiGetWindowRect iHwnd, rc
#End If
    Call newRect.SetRect(rc.left, rc.top, rc.right, rc.bottom)
    Set GetWindowRect = newRect
End Function

Public Function IsWindowUnicode() As Boolean
Attribute IsWindowUnicode.VB_HelpID = 2876
Attribute IsWindowUnicode.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    If apiIsWindowUnicode(iHwnd) = 0 Then
        IsWindowUnicode = False
    Else
        IsWindowUnicode = True
    End If
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Function

Public Function IsWindow() As Boolean
Attribute IsWindow.VB_HelpID = 2785
Attribute IsWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsWindow(iHwnd) = 0 Then
        IsWindow = False
    Else
        IsWindow = True
    End If
End Function

Public Function IsWindowVisible() As Boolean
Attribute IsWindowVisible.VB_HelpID = 2801
Attribute IsWindowVisible.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsWindowVisible(iHwnd) = 0 Then
        IsWindowVisible = False
    Else
        IsWindowVisible = True
    End If
End Function

Public Sub InvalidateRect(lpdwRect As dwRECT, bErase As Boolean)
Attribute InvalidateRect.VB_HelpID = 2931
Attribute InvalidateRect.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiInvalidateRectBynum(iHwnd, lpdwRect.GetAddress(), CLng(bErase))
    If ret& = 0 Then RaiseWinError
#Else
    apiInvalidateRectBynum iHwnd, lpdwRect.GetAddress(), CInt(bErase)
#End If
End Sub

#If FlagRegion Then
Public Sub InvalidateRgn(rRegion As dwRegion, bErase As Boolean)
Attribute InvalidateRgn.VB_HelpID = 2935
Attribute InvalidateRgn.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiInvalidateRgn(iHwnd, rRegion.hRegion, CLng(bErase))
#Else
    ret& = apiInvalidateRgn(iHwnd, rRegion.hRegion, CInt(bErase))
#End If
    If ret& = 0 Then RaiseWinError
End Sub
#End If ' FlagRegion

Public Function IsChild(hWndOther As dwWindow) As Boolean
Attribute IsChild.VB_HelpID = 2787
Attribute IsChild.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsChild(iHwnd, hWndOther.hwnd) = 0 Then
        IsChild = False
    Else
        IsChild = True
    End If
End Function

Public Function IsIconic() As Boolean
Attribute IsIconic.VB_HelpID = 2802
Attribute IsIconic.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsIconic(iHwnd) = 0 Then
        IsIconic = False
    Else
        IsIconic = True
    End If
End Function

Public Function IsZoomed() As Boolean
Attribute IsZoomed.VB_HelpID = 2805
Attribute IsZoomed.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If apiIsZoomed(iHwnd) = 0 Then
        IsZoomed = False
    Else
        IsZoomed = True
    End If
End Function

Public Sub LockWindowUpdate(Locking As Boolean)
Attribute LockWindowUpdate.VB_HelpID = 2938
Attribute LockWindowUpdate.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    If Locking = True Then
        ret& = apiLockWindowUpdate(iHwnd)
    Else
        ret& = apiLockWindowUpdate(0)
    End If
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub MoveWindow(ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, bRepaint As Boolean)
Attribute MoveWindow.VB_HelpID = 2794
Attribute MoveWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiMoveWindow(iHwnd, x, y, nWidth, nHeight, CLng(bRepaint))
    If ret& = 0 Then RaiseWinError
#Else
    apiMoveWindow iHwnd, x, y, nWidth, nHeight, CInt(bRepaint)
#End If
End Sub

Public Sub OpenIcon()
Attribute OpenIcon.VB_HelpID = 2792
Attribute OpenIcon.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiOpenIcon(iHwnd)
    If ret& = 0 Then RaiseWinError
End Sub

#If FlagRedrawWindow Then
Public Sub RedrawWindow(lprcUpdate As dwRECT, hRgnUpdate As dwRegion, ByVal fuRedraw)
Attribute RedrawWindow.VB_HelpID = 2937
Attribute RedrawWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim tempRect As RECT
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect.left)
    ret& = apiRedrawWindow(iHwnd, tempRect, hRgnUpdate.hRegion, fuRedraw)
    If ret& = 0 Then RaiseWinError
End Sub
#End If

Public Sub ReleaseCapture()
Attribute ReleaseCapture.VB_HelpID = 2873
Attribute ReleaseCapture.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiReleaseCapture()
    If ret& = 0 Then RaiseWinError
#Else
    apiReleaseCapture
#End If
End Sub

Public Sub UpdateWindow()
Attribute UpdateWindow.VB_HelpID = 2917
Attribute UpdateWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiUpdateWindow(iHwnd)
    If ret& = 0 Then RaiseWinError
#Else
    apiUpdateWindow iHwnd
#End If
End Sub

Public Sub ScreenToClient(ByVal pPoint As dwPoint)
Attribute ScreenToClient.VB_HelpID = 2978
Attribute ScreenToClient.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim tempPoint As POINTAPI
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    tempPoint.x = pPoint.x
    tempPoint.y = pPoint.y
#If Win32 Then
    ret& = apiScreenToClient(iHwnd, tempPoint)
    If ret& = 0 Then RaiseWinError
#Else
    apiScreenToClient iHwnd, tempPoint
#End If
    pPoint.x = tempPoint.x
    pPoint.y = tempPoint.y
End Sub

Public Sub ClientToScreen(pPoint As dwPoint)
Attribute ClientToScreen.VB_HelpID = 2977
Attribute ClientToScreen.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim tempPoint As POINTAPI
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    tempPoint.x = pPoint.x
    tempPoint.y = pPoint.y
#If Win32 Then
    ret& = apiClientToScreen(iHwnd, tempPoint)
    If ret& = 0 Then RaiseWinError
#Else
    apiClientToScreen iHwnd, tempPoint
#End If
    pPoint.x = tempPoint.x
    pPoint.y = tempPoint.y
End Sub

' lpdwRect is a dwRect, lpClipdwRect is a dwRect
Public Sub ScrollWindow(ByVal XAmount, ByVal YAmount, Optional lpdwRect As Variant, Optional lpClipdwRect As Variant)
Attribute ScrollWindow.VB_HelpID = 2939
Attribute ScrollWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim tempRect1 As RECT
    Dim tempRect2 As RECT
    Dim ret&

    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    If IsMissing(lpClipdwRect) Then
        If IsMissing(lpdwRect) Then
            #If Win32 Then
                ret& = apiScrollWindowByval(iHwnd, XAmount, YAmount, 0, 0)
                If ret& = 0 Then RaiseWinError
            #Else
                apiScrollWindowByval iHwnd, XAmount, YAmount, 0, 0
            #End If
        Else
            lpdwRect.CopyToRECT agGetAddressForObject(tempRect1.left)
            #If Win32 Then
                ret& = apiScrollWindowByval(iHwnd, XAmount, YAmount, agGetAddressForObject(tempRect1), 0)
                If ret& = 0 Then RaiseWinError
            #Else
                apiScrollWindowByval iHwnd, XAmount, YAmount, agGetAddressForObject(tempRect1), 0
            #End If
        End If
    Else
        If IsMissing(lpdwRect) Then
            lpClipdwRect.CopyToRECT agGetAddressForObject(tempRect2.left)
            #If Win32 Then
                ret& = apiScrollWindowByval(iHwnd, XAmount, YAmount, 0, agGetAddressForObject(tempRect2))
                If ret& = 0 Then RaiseWinError
            #Else
                apiScrollWindowByval iHwnd, XAmount, YAmount, 0, agGetAddressForObject(tempRect2)
            #End If
        Else
            lpdwRect.CopyToRECT agGetAddressForObject(tempRect1.left)
            lpClipdwRect.CopyToRECT agGetAddressForObject(tempRect2.left)
            #If Win32 Then
                ret& = apiScrollWindowByval(iHwnd, XAmount, YAmount, agGetAddressForObject(tempRect1), agGetAddressForObject(tempRect2))
                If ret& = 0 Then RaiseWinError
            #Else
                apiScrollWindowByval iHwnd, XAmount, YAmount, agGetAddressForObject(tempRect1), agGetAddressForObject(tempRect2)
            #End If
        End If
    End If
End Sub

' lprcScroll As dwRECT, lprcClip As dwRECT, hRgnUpdate As dwRegion, lprcUpdate As dwRECT, fuScroll as long
Public Sub ScrollWindowEx(ByVal dx As Long, ByVal dy As Long, Optional lprcScroll As Variant, Optional lprcClip As Variant, Optional hRgnUpdate As Variant, Optional lprcUpdate As Variant, Optional fuScroll As Variant)
Attribute ScrollWindowEx.VB_HelpID = 2941
Attribute ScrollWindowEx.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret&
    Dim tempRect1 As RECT
    Dim tempRect2 As RECT
    Dim tempRect3 As RECT
    Dim tempflags As Long
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    If IsMissing(fuScroll) Then
        tempflags = 0
    Else
        tempflags = fuScroll
    End If
    
    If IsMissing(lprcScroll) Then
        If IsMissing(lprcClip) Then
            If IsMissing(hRgnUpdate) Then
                If IsMissing(lprcUpdate) Then
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, 0, 0, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, 0, 0, agGetAddressForObject(tempRect1), tempflags)
                End If
            Else
                If IsMissing(lprcUpdate) Then
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, 0, hRgnUpdate.hRegion, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, 0, hRgnUpdate.hRegion, agGetAddressForObject(tempRect1), tempflags)
                End If
            End If
        Else
            If IsMissing(hRgnUpdate) Then
                If IsMissing(lprcUpdate) Then
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, agGetAddressForObject(tempRect2), 0, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, agGetAddressForObject(tempRect2), 0, agGetAddressForObject(tempRect1), tempflags)
                End If
            Else
                If IsMissing(lprcUpdate) Then
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, agGetAddressForObject(tempRect2), hRgnUpdate.hRegion, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, 0, agGetAddressForObject(tempRect2), hRgnUpdate.hRegion, agGetAddressForObject(tempRect1), tempflags)
                End If
            End If
        End If
    Else
        If IsMissing(lprcClip) Then
            If IsMissing(hRgnUpdate) Then
                If IsMissing(lprcUpdate) Then
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), 0, 0, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), 0, 0, agGetAddressForObject(tempRect1), tempflags)
                End If
            Else
                If IsMissing(lprcUpdate) Then
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), 0, hRgnUpdate.hRegion, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), 0, hRgnUpdate.hRegion, agGetAddressForObject(tempRect1), tempflags)
                End If
            End If
        Else
            If IsMissing(hRgnUpdate) Then
                If IsMissing(lprcUpdate) Then
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), agGetAddressForObject(tempRect2), 0, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), agGetAddressForObject(tempRect2), 0, agGetAddressForObject(tempRect1), tempflags)
                End If
            Else
                If IsMissing(lprcUpdate) Then
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), agGetAddressForObject(tempRect2), hRgnUpdate.hRegion, 0, tempflags)
                Else
                    lprcUpdate.CopyToRECT agGetAddressForObject(tempRect1.left)
                    lprcClip.CopyToRECT agGetAddressForObject(tempRect2.left)
                    lprcScroll.CopyToRECT agGetAddressForObject(tempRect3.left)
                    ret& = apiScrollWindowExByval(iHwnd, dx, dy, agGetAddressForObject(tempRect3), agGetAddressForObject(tempRect2), hRgnUpdate.hRegion, agGetAddressForObject(tempRect1), tempflags)
                End If
            End If
        End If
    End If

    If ret& = 0 Then RaiseWinError
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Sub

Public Sub SetActiveWindow()
Attribute SetActiveWindow.VB_HelpID = 2918
Attribute SetActiveWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetActiveWindow(iHwnd)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub SetCapture()
Attribute SetCapture.VB_HelpID = 2872
Attribute SetCapture.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetCapture(iHwnd)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub SetFocus()
Attribute SetFocus.VB_HelpID = 2852
Attribute SetFocus.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetFocus(iHwnd)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub SetForegroundWindow()
Attribute SetForegroundWindow.VB_HelpID = 2920
Attribute SetForegroundWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetForegroundWindow(iHwnd)
    If ret& = 0 Then RaiseWinError
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Sub

Public Sub SetParent(hWndNewParent As dwWindow)
Attribute SetParent.VB_HelpID = 3009
Attribute SetParent.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetParent(iHwnd, hWndNewParent.hwnd)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub SetWindowPos(hWndInsertAfter As dwWindow, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags)
Attribute SetWindowPos.VB_HelpID = 2795
Attribute SetWindowPos.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiSetWindowPos(iHwnd, hWndInsertAfter.hwnd, x, y, cx, cy, wFlags)
    If ret& = 0 Then RaiseWinError
#Else
    apiSetWindowPos iHwnd, hWndInsertAfter.hwnd, x, y, cx, cy, wFlags
#End If
End Sub

Public Sub SetWindowText(lpString As String)
Attribute SetWindowText.VB_HelpID = 2951
Attribute SetWindowText.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiSetWindowText(iHwnd, lpString)
    If ret& = 0 Then RaiseWinError
#Else
    apiSetWindowText iHwnd, lpString
#End If
End Sub

Public Sub SetWindowWord(ByVal nIndex, dwNewWord As Integer)
Attribute SetWindowWord.VB_HelpID = 3000
Attribute SetWindowWord.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiSetWindowWord(iHwnd, nIndex, dwNewWord)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub ShowOwnedPopups(fshow As Boolean)
Attribute ShowOwnedPopups.VB_HelpID = 2791
Attribute ShowOwnedPopups.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiShowOwnedPopups(iHwnd, CLng(fshow))
    If ret& = 0 Then RaiseWinError
#Else
    apiShowOwnedPopups iHwnd, CInt(fshow)
#End If
End Sub

Public Sub ShowWindow(ByVal nCmdShow As Long)
Attribute ShowWindow.VB_HelpID = 2789
Attribute ShowWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiShowWindow(iHwnd, nCmdShow)
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub ShowWindowAsync(ByVal nCmdShow As Long) ' causes error
Attribute ShowWindowAsync.VB_HelpID = 3444
Attribute ShowWindowAsync.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiShowWindowAsync(iHwnd, nCmdShow)
    If ret& = 0 Then RaiseWinError
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Sub

Public Sub ValidateRect(lpdwRect As dwRECT)
Attribute ValidateRect.VB_HelpID = 2933
Attribute ValidateRect.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiValidateRectBynum(iHwnd, lpdwRect.GetAddress())
    If ret& = 0 Then RaiseWinError
#Else
    apiValidateRectBynum iHwnd, lpdwRect.GetAddress()
#End If
End Sub

' This is a replacement for somehow passing 0 to
' ValidateRect.
Public Sub ValidateWindow()
Attribute ValidateWindow.VB_HelpID = 2934
Attribute ValidateWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiValidateRectBynum(iHwnd, 0)
    If ret& = 0 Then RaiseWinError
#Else
    apiValidateRectBynum iHwnd, 0
#End If
End Sub

Public Sub ArrangeIconicWindows()
Attribute ArrangeIconicWindows.VB_HelpID = 2049
Attribute ArrangeIconicWindows.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    
    ret& = apiArrangeIconicWindows(iHwnd)
    If ret& = 0 Then RaiseWinError
End Sub

Public Function WindowFromPoint(pPoint As dwPoint) As dwWindow
Attribute WindowFromPoint.VB_HelpID = 2980
Attribute WindowFromPoint.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret As Long
#Else
    Dim ret As Integer
    Dim lPnt As Long
#End If
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret = apiWindowFromPoint(pPoint.x, pPoint.y)
#Else
    lPnt = (pPoint.x * 65536) + pPoint.y ' convert point coordinates into a long integer
    ret = apiWindowFromPoint(lPnt)
#End If
    If ret = 0 Then RaiseWinError
    newWindow.hwnd = ret
    Set WindowFromPoint = newWindow
End Function

Public Function ChildWindowFromPoint(pPoint As dwPoint) As dwWindow
Attribute ChildWindowFromPoint.VB_HelpID = 2981
Attribute ChildWindowFromPoint.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret As Long
#Else
    Dim ret As Integer
    Dim lPnt As Long
#End If
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret = apiChildWindowFromPoint(iHwnd, pPoint.x, pPoint.y)
#Else
    lPnt = (pPoint.x * 65536) + pPoint.y ' convert point coordinates into a long integer
    ret = apiChildWindowFromPoint(iHwnd, lPnt)
#End If
    If ret = 0 Then RaiseWinError
    newWindow.hwnd = ret
    Set ChildWindowFromPoint = newWindow
End Function

Public Function ChildWindowFromPointEx(pPoint As dwPoint, uFlags As Long) As dwWindow
Attribute ChildWindowFromPointEx.VB_HelpID = 3434
Attribute ChildWindowFromPointEx.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret&
    Dim newWindow As New dwWindow
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiChildWindowFromPointEx(iHwnd, pPoint.x, pPoint.y, uFlags)
    If ret& = 0 Then RaiseWinError
    newWindow.hwnd = ret&
    Set ChildWindowFromPointEx = newWindow
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Function

Public Function GetClassName() As String
Attribute GetClassName.VB_HelpID = 3011
Attribute GetClassName.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim clsName$
    Dim length&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    clsName$ = String$(MAX_LEN, 0)
    length& = Len(clsName$)
    length& = apiGetClassName(iHwnd, clsName$, length& + 1)
    GetClassName = left$(clsName$, length&)
End Function

Public Function GetClassLong(ByVal nIndex As Long) As Long
Attribute GetClassLong.VB_HelpID = 2005
Attribute GetClassLong.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    GetClassLong = apiGetClassLong(iHwnd, nIndex)
End Function

Public Function FlashWindow(bInvert As Boolean) As Boolean
Attribute FlashWindow.VB_HelpID = 2790
Attribute FlashWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    FlashWindow = apiFlashWindow(iHwnd, CLng(bInvert))
#Else
    FlashWindow = apiFlashWindow(iHwnd, CInt(bInvert))
#End If
End Function

' dwWindow, string, string
Public Function FindWindowEx(Optional hWndChildAfter As Variant, Optional lpClassName As Variant, Optional lpWindowName As Variant) As dwWindow
Attribute FindWindowEx.VB_HelpID = 3440
Attribute FindWindowEx.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
#If Win32 Then
    Dim ret&
    Dim newWindow As New dwWindow

    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiFindWindowEx(iHwnd, hWndChildAfter.hwnd, CStr(lpClassName), CStr(lpWindowName))
    newWindow.hwnd = ret&
    Set FindWindowEx = newWindow
#Else
    RaiseWinError DWERR_NOTINWIN16
#End If
End Function

Public Sub EnableWindow(ByVal fEnable As Boolean)
Attribute EnableWindow.VB_HelpID = 2877
Attribute EnableWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret& = apiEnableWindow(iHwnd, CLng(fEnable))
    'Checking ret& is not needed since EnableWindow can return either true OR false on success.
End Sub

Public Sub CloseWindow()
Attribute CloseWindow.VB_HelpID = 2793
Attribute CloseWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret&
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
#If Win32 Then
    ret& = apiCloseWindow(iHwnd)
#Else
    apiCloseWindow iHwnd
#End If
    If ret& = 0 Then RaiseWinError
End Sub

Public Sub DestroyWindow()
Attribute DestroyWindow.VB_HelpID = 2788
Attribute DestroyWindow.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim ret As Boolean
    
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    ret = apiDestroyWindow(iHwnd)
    If ret = False Then RaiseWinError
End Sub


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The following is for compatibility with the
' API Foundation Library Standard.  It is not a full
' implementation, as this library was completed before
' the final version of the standard was completed.
' There are also a number of functions that are not
' completed for lack of time or because adequate
' documentation was not provided.  The API foundation standard
' may change at any time after this libray is released,
' so the functions below may not be correct.

' The "Attach" functions are ways of setting up the
' class.  Most of the functions below are the same
' as the API functions above, but are renamed for
' some reason.


Public Sub Attach(newHwnd As Long)
    Dim tmpDwRect As New dwRECT
    
    If newHwnd = 0 Then
        iHwnd = newHwnd
        Exit Sub
    End If
    
    If apiIsWindow(newHwnd) = 0 Then
        RaiseWinError 380
        Exit Sub
    End If
    iHwnd = newHwnd
    
    Set tmpDwRect = GetWindowRect()
    iLeft = tmpDwRect.left
    iTop = tmpDwRect.top
    iWidth = tmpDwRect.right - tmpDwRect.left
    iHeight = tmpDwRect.bottom - tmpDwRect.top
    Set tmpDwRect = Nothing
End Sub

Public Sub AttachDesktop()
    Dim tmpDwRect As New dwRECT
    
    iHwnd = apiGetDesktopWindow()
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    
    Set tmpDwRect = GetWindowRect()
    iLeft = tmpDwRect.left
    iTop = tmpDwRect.top
    iWidth = tmpDwRect.right - tmpDwRect.left
    iHeight = tmpDwRect.bottom - tmpDwRect.top
    Set tmpDwRect = Nothing
End Sub

Public Sub AttachForeground()
    Dim tmpDwRect As New dwRECT

#If Win32 Then
    iHwnd = apiGetForegroundWindow()
#Else
    iHwnd = apiGetTopWindow(iHwnd)
#End If
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    
    Set tmpDwRect = GetWindowRect()
    iLeft = tmpDwRect.left
    iTop = tmpDwRect.top
    iWidth = tmpDwRect.right - tmpDwRect.left
    iHeight = tmpDwRect.bottom - tmpDwRect.top
    Set tmpDwRect = Nothing
End Sub

Public Sub AttachFromPoint(pPoint As dwPoint)
    Dim tmpDwRect As New dwRECT
    Dim lPnt As Long
    
#If Win32 Then
    iHwnd = apiChildWindowFromPoint(iHwnd, pPoint.x, pPoint.y)
#Else
    lPnt = (pPoint.x * 65536) + pPoint.y ' convert point coordinates into a long integer
    iHwnd = apiChildWindowFromPoint(iHwnd, lPnt)
#End If
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    
    Set tmpDwRect = GetWindowRect()
    iLeft = tmpDwRect.left
    iTop = tmpDwRect.top
    iWidth = tmpDwRect.right - tmpDwRect.left
    iHeight = tmpDwRect.bottom - tmpDwRect.top
    Set tmpDwRect = Nothing
End Sub

Public Sub Detach()
    iHwnd = 0
End Sub

Public Sub BringToTop()
Attribute BringToTop.VB_HelpID = 2804
Attribute BringToTop.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    BringWindowToTop
End Sub

Public Function ChildFromPoint(pPoint As dwPoint) As dwWindow
    Set ChildFromPoint = ChildWindowFromPoint(pPoint)
End Function

Public Function ClassName() As String
Attribute ClassName.VB_HelpID = 3011
Attribute ClassName.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    ClassName = GetClassName()
End Function

Public Function ClientRectangle() As dwRECT
Attribute ClientRectangle.VB_HelpID = 2954
Attribute ClientRectangle.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Set ClientRectangle = GetClientRect()
End Function

Public Sub Destroy()
    DestroyWindow
    ' clear any memory used in this class here
End Sub

Public Sub DragAcceptFiles(accept As Boolean)
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    apiDragAcceptFiles iHwnd, accept
End Sub

Public Sub Flash(invert As Boolean)
    FlashWindow invert
End Sub

Public Sub Invalidate()
    InvalidateRect GetWindowRect(), True
End Sub

Public Sub InvalidateRectangle(rRect As dwRECT, bErase As Boolean)
    InvalidateRect rRect, bErase
End Sub

#If FlagRegion Then
Public Sub InvalidateRegion(rRegion As dwRegion, bErase As Boolean)
    InvalidateRgn rRegion, bErase
End Sub
#End If ' FlagRegion

Public Sub Move(left As Single, Optional top As Variant, Optional Width As Variant, Optional Height As Variant)
Attribute Move.VB_HelpID = 2794
Attribute Move.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    Dim tmpTop As Long
    Dim tmpWidth As Long
    Dim tmpHeight As Long
    
    If IsMissing(top) Then
        tmpTop = iTop
    Else
        tmpTop = top
    End If
    
    If IsMissing(Width) Then
        tmpWidth = iWidth
    Else
        tmpWidth = Width
    End If
    
    If IsMissing(Height) Then
        tmpHeight = iHeight
    Else
        tmpHeight = Height
    End If
    MoveWindow left, tmpTop, tmpWidth, tmpHeight, True
End Sub

#If FlagRedrawWindow Then
Public Sub Redraw()
    Dim tmpRect As New dwRECT
    Dim tmpRgn As New dwRegion
    
    tmpRect = GetWindowRect()
    RedrawWindow tmpRect, tmpRgn, True
End Sub
#End If 'FlagRedrawWindow

#If FlagRedrawWindow Then
Public Sub Refresh(Optional ForceInvalidate As Variant)
    Dim tmpRect As New dwRECT
    Dim tmpRgn As New dwRegion
    
    tmpRect = GetWindowRect()
    If IsMissing(ForceInvalidate) Then
        RedrawWindow tmpRect, tmpRgn, True
    Else
        RedrawWindow tmpRect, tmpRgn, ForceInvalidate
    End If
End Sub
#End If ' FlagRedrawWindow

Public Sub Scroll(ByVal XAmount, ByVal YAmount, Optional lpdwRect As Variant, Optional lpClipdwRect As Variant)
    ScrollWindow XAmount, YAmount, lpdwRect, lpClipdwRect
End Sub

#If Win32 Then
Public Function SendMessage(nMsg As Integer, wParam As Long, lParam As Long) As Long
Attribute SendMessage.VB_HelpID = 2761
Attribute SendMessage.VB_Description = "Help available in Visual Basic Programmer's Guide to Win32 API CD ROM"
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    SendMessage = apiSendMessage(iHwnd, nMsg, wParam, lParam)
End Function
#Else ' win16
Public Function SendMessage(nMsg As Integer, wParam As Integer, lParam As Long) As Long
    If iHwnd = 0 Then RaiseWinError DWERR_UNINITIALIZED
    SendMessage = apiSendMessage(iHwnd, nMsg, wParam, lParam)
End Function
#End If

Public Function Show(Optional mode As Variant)
    ShowWindow mode
End Function

Public Function ShowPopups()
    ShowOwnedPopups True
End Function

' This property is called "pLeft" instead of "Left" because it
' causes VB to think that the Left$ function (which is used a
' couple of times in this class) is actually a reference to the
' property.
Public Property Get pLeft()
    pLeft = iLeft
End Property

Public Property Let pLeft(vNewValue)
    iLeft = vNewValue
    MoveWindow iLeft, iTop, iWidth, iHeight, True
End Property

Public Property Get top()
    top = iTop
End Property

Public Property Let top(vNewValue)
    iTop = vNewValue
    MoveWindow iLeft, iTop, iWidth, iHeight, True
End Property

Public Property Get Width()
    Width = iWidth
End Property

Public Property Let Width(vNewValue)
    iWidth = vNewValue
    MoveWindow iLeft, iTop, iWidth, iHeight, True
End Property

Public Property Get Height()
    Height = iHeight
End Property

Public Property Let Height(vNewValue)
    iHeight = vNewValue
    MoveWindow iLeft, iTop, iWidth, iHeight, True
End Property

